option title, "Simutrans savegame (.sve)"

= *****************************************************************************
= Savegame must be binary
= *****************************************************************************

REQUIRE 'def.mps'

option GlobalVars, 1
option ReadTags, 1
option target, structureviewer

= open active editor and goto current position/0
	var editor file
	var _filesize longword
	editor = fileopen('::current')
=if ((param_count > 0) and (dword(params(0))==1))
	fileseek editor, 0

	var start dword
	start = filegetprop(editor, 'position')

	= open browser window
	var browser file
	browser = fileopen('::browser', 'c')

	filesetprop browser, 'accepttags', 1
	filewrite browser "<font color=",'"',"blue",'"',"><b><u># Simutrans sve file structure:</u></b></font>\n\n"
	=filesetprop browser, 'accepttags', 0
	_filesize = filesize(editor)
	filewrite browser "# filesize = ",_filesize,"\n"
	filewrite browser "# File: '",filegetprop(editor, 'filename'),"'\n"
	filewrite browser "# <i>Italic</i> are readonly. Do not change them !\n\n"

	var _text text _text1 text _text2 text
	var _byte byte _char char _word word _dword dword _pos dword _longword longword _longword2 longword
	var _db double _version dword _supportVersion dword _start dword _sigword sigword _lcount word
	  _pos = filepos(editor)
	var _head text _siglongword siglongword
	var _sigqword sigqword _is_exp char _exp_ver word

	_supportVersion = 111000

= *****************************************************************************
= check header
= *****************************************************************************

	fileread editor _head 64
	_text1 = textline(_head,0)
	_dword = textlen(_text1)

	_text2 = textcut(@_text1, 0, 10)
	if _text2 != "Simutrans "
		filewrite browser "This is not a binary sve.\n"
		goto finish
	endif
	_text1=textcopy(_text1,11)


= *****************************************************************************
= check version
= uint32 version = v0 * 1000000 + v1 * 1000 + v2
= *****************************************************************************

	_longword = textpos(".", _text1)
	if _longword == 0
		filewrite browser "Broken version number 01.\n"
		goto finish
	endif
	_text2 = textcut(@_text1, 0, _longword-1)
	_text1=textcopy(_text1,_longword+1)

	LET _longword=longword(_text2)
	_version = _longword * 1000000
	_text2 = textcut(@_text1, 0, 1)

	_longword = textpos(".", _text1)
	if _longword == 0
		filewrite browser "Broken version number 02.\n"
		goto finish
	endif
	_text2 = textcut(@_text1, 0, _longword-1)
	_text1=textcopy(_text1,_longword+1)
	LET _longword=longword(_text2)
	_version = _version + _longword * 1000
	_text2 = textcut(@_text1, 0, 1)

	var _temp_text text
	_text2=""
	_temp_text=textcut(@_text1, 0, 1)
	while ( (_temp_text>"-") and (_temp_text<":"))
		_text2=_text2+_temp_text
		_text1=textcopy(_text1,2)
		_temp_text=textcut(@_text1, 0, 1)
	endwhile

	_is_exp = 0
	_exp_ver = 0
	if not ISNUMBER(_text2)
		_is_exp = 1
		_text1=_text2
		_longword = textpos(".", _text1)
		if _longword == 0
			filewrite browser "Broken version number 03.\n"
			goto finish
		endif
		_text2 = textcut(@_text1, 0, _longword-1)
		_text1=textcopy(_text1,_longword+1)

		LET _exp_ver = word(_text1)
		filewrite browser "Experimental version=", dec(_exp_ver), "\n"

		filewrite browser "# Sorry, we don't support experimental version.\n"
		goto finish
	endif

	LET _longword=longword(_text2)
	_version = _version + _longword
	filewrite browser "version=", dec(_version), "\n"
	if _version>_supportVersion
		filewrite browser "# This savegame version is not supported yet.\n"
	endif
	filewrite browser "\n"

	fileseek editor,_dword+1,0

= *****************************************************************************
= read data from here !
= *****************************************************************************
	if _version<86000
		call("_read_sint32","<i>map size</i>")
		call("_read_sint32","<i>number???</i>")
		call("_read_sint32","industrie_dichte???")
		call("_read_sint32","towns")
		call("_read_uint32","scroll speed")
		call("_read_sint32","traffic")
		call("_read_sint32","show pax")
		call("_read_sint32","<i>water level</i>")
		call("_read_double","<i>max_mountain_height</i>")
		call("_read_double","<i>map_roughness hageshisa</i>")
		call("_read_uint32","time??")
		call("_read_uint32","month??")
		call("_read_uint32","year??")
		goto finish
	endif

	call("_read_sint32","<i>map size x</i>")
	call("_read_sint32","<i>map No.</i>")
	call("_read_sint32","land factories")

	if _version<99018
		call("_read_uint32","city chains")
	else
		call("_read_sint32","electric_promille")
	endif

	call("_read_sint32","attraction")
	call("_read_sint32","population")
	call("_read_sint32","towns")

	if _version<101000
		call("_read_uint32","scroll speed")
	endif

	call("_read_sint32","<b>traffic</b>")
	call("_read_sint32","show pax")
	call("_read_sint32","<i>water level</i>")
	call("_read_double","<i>max_mountain_height</i>")
	call("_read_double","<i>map_roughness hageshisa</i>")

	if _version>=86003
		call("_read_uint16","<b>station_coverage_size</b>")
	endif
	fileseek editor,2,1

	if _version>=86006
		call("_read_sint32","<i>map size y</i>")
	endif

	if _version>=86011
		call("_read_uint8","allow_player_change")
		call("_read_uint8","<b>use_timeline</b>")
		call("_read_sint16","<i>start year</i>")
	endif

	if _version>=88005
		call("_read_sint16","<b>bit per month</b>")
	endif

	if _version>=89003
	call("_read_bool","beginner mode")
	endif

	if _version>=89004
		call("_read_bool","<b>just_in_time</b>")
	endif

	if _version>=99015
		call("_read_uint8","<i>rotation</i>")
	endif

	if _version>=91000
		filewrite browser "\n"
		call("_read_sint16","water")
		call("_read_sint16","desert")
		call("_read_sint16","tropic")
		call("_read_sint16","mediterran")
		call("_read_sint16","temperate")
		call("_read_sint16","tundra")
		call("_read_sint16","rocky")
		call("_read_sint16","<b>summer snowline</b>")
		call("_read_sint16","winter snowline")
		filewrite browser "\n"
	endif

	if _version>99018
		call("_read_uint16","diagonal_multiplier")
	endif

	if _version>=101000
		call("_read_sint16","<i>origin_x</i>")
		call("_read_sint16","<i>origin_y</i>")
		filewrite browser "\n"
		call("_read_sint32","<b>passenger_factor</b>")
	endif

	if _version>102001
		call("_read_sint32","passenger_multiplier")
		call("_read_sint32","mail_multiplier")
		call("_read_sint32","goods_multiplier")
		call("_read_sint32","electricity_multiplier")
		call("_read_sint32","growthfactor_small")
		call("_read_sint32","growthfactor_medium")
		call("_read_sint32","growthfactor_large")
		call("_read_sint16","<b>factory_worker_percentage</b>")
		call("_read_sint16","tourist_percentage")
		call("_read_sint16","factory_worker_radius")
		filewrite browser "\n"
	endif

	if _version>=101000
		call("_read_uint32","default_electric_promille")
		call("_read_sint16","factory_spacing")
		call("_read_bool","crossconnect_factories")
		call("_read_sint16","crossconnect_factor")
		call("_read_bool","pedestrian")
		call("_read_sint32","<b>default_citycar_life</b>")
		call("_read_bool","numbered_stations")

		if _version<=102002
			call("_read_text","city_road_type")
		else
			filewrite browser "\n"
			call _get_cityroad
			filewrite browser "\n"
		endif

		call("_read_sint32","max_route_steps")
		call("_read_sint32","max_transfers")
		call("_read_sint32","max_hops")
		call("_read_sint32","beginner_price_factor")
		call("_read_text","language_code_names")
		filewrite browser "\n"
		call _get_player
		filewrite browser "\n"
		call("_read_bool","freeplay")
= money
		filewrite browser "\n"
		call("_read_sint64","starting_money")
		if _version>102002
			call _get_startingmoney
		endif
		filewrite browser "\n"
		call("_read_sint32","maint_building")
		call("_read_sint64","cst_multiply_dock")
		call("_read_sint64","cst_multiply_station")
		call("_read_sint64","cst_multiply_roadstop")
		call("_read_sint64","cst_multiply_airterminal")
		call("_read_sint64","cst_multiply_post")
		call("_read_sint64","cst_multiply_headquarter")
		call("_read_sint64","cst_depot_rail")
		call("_read_sint64","cst_depot_road")
		call("_read_sint64","cst_depot_ship")
		call("_read_sint64","cst_depot_air")

		if _version<=102001
			call("_read_sint64","cst_signal")
			call("_read_sint64","cst_tunnel")
			call("_read_sint64","cst_third_rail")
		endif

		call("_read_sint64","cst_buy_land")
		call("_read_sint64","cst_alter_land")
		call("_read_sint64","cst_set_slope")
		call("_read_sint64","cst_found_city")
		call("_read_sint64","cst_multiply_found_industry")
		call("_read_sint64","cst_remove_tree")
		call("_read_sint64","cst_multiply_remove_haus")
		call("_read_sint64","cst_multiply_remove_field")
		call("_read_sint64","cst_transformer")
		call("_read_sint64","cst_maintain_transformer")
= way builder
		filewrite browser "\n"
		call("_read_sint32","way_count_straight")
		call("_read_sint32","way_count_curve")
		call("_read_sint32","way_count_double_curve")
		call("_read_sint32","way_count_90_curve")
		call("_read_sint32","way_count_slope")
		call("_read_sint32","way_count_tunnel")
		call("_read_uint32","way_max_bridge_len")
		call("_read_sint32","way_count_leaving_road")
		filewrite browser "\n"
	endif

	if _version>101000
		call("_read_bool","<b>seperate_halt_capacities</b>")
		call("_read_uint8","pay_for_total_distance")
		call("_read_sint16","<i>starting_month</i>")
		call("_read_sint16","river_number")
		call("_read_sint16","min_river_length")
		call("_read_sint16","max_river_length")
	endif

	if _version>102000
		filewrite browser "\n"
		call("_read_bool","avoid_overcrowding")
	endif

	if _version>102001
		call("_read_bool","<b>no_routing_over_overcrowding</b>")
		call("_read_bool","<i>with_private_paks</i>")
	endif

	if _version>=102003
		call("_read_uint32","random_counter")
		call("_read_uint32","frames_per_second")
		call("_read_uint32","frames_per_step")
		call("_read_bool","<b>allow_buying_obsolete_vehicles</b>")
		call("_read_sint32","factory_worker_minimum_towns")
		call("_read_sint32","factory_worker_maximum_towns")
		filewrite browser "\n"
		call("_read_uint8","forest_base_size")
		call("_read_uint8","forest_map_size_divisor")
		call("_read_uint8","forest_count_divisor")
		call("_read_uint16","forest_inverse_spare_tree_density")
		call("_read_uint8","max_no_of_trees_on_square")
		call("_read_uint16","tree_climates")
		call("_read_uint16","no_tree_climates")
		call("_read_bool","no_trees")
		filewrite browser "\n"
		call("_read_uint32","minimum_city_distance")
		call("_read_uint32","<b>industry_increase</b>")
	endif

	if _version>=110000
		call("_read_uint32","server_frames_ahead")
		call("_read_sint16","used_vehicle_reduction")
	endif

	if _version>=110001
		call("_read_bool","random_player_colors")
		filewrite browser "\n"
		call _get_player_color
		filewrite browser "\n"
	endif

	if _version>=110005
		call("_read_uint16","factory_arrival_periods")
		call("_read_bool","factory_enforce_demand")
	endif

	if _version>=110007
		filewrite browser "\n"
		call _get_localityfactor
		filewrite browser "\n"
		call("_read_bool","<b>drive_left</b>")
		call("_read_bool","<b>signals_on_left</b>")
		call("_read_sint32","toll_runningcost_percentage")
		call("_read_sint32","toll_waycost_percentage")
	endif

=       default.sve doesn't have these
	if filepos(editor) < _filesize
		filewrite browser "\n"
		call("_read_uint32","<i>tick</i>")
		call("_read_uint32","current month (0-11)")
		call("_read_uint32","current year")
		filewrite browser "\n"
	else
		goto finish
	endif

= *****************************************************************************
=  Network game stuff
= *****************************************************************************

	if _version>102002
		fileread editor _char
		if _char == 49
			filewrite browser "# Network game only\n"
			call("_read_uint32","renovation_percentage")
			call("_read_uint32","min_building_density")
			call("_read_sint16","ind_start_score")
			call("_read_sint16","\tind_neighbour_score[0]")
			call("_read_sint16","\tind_neighbour_score[1]")
			call("_read_sint16","\tind_neighbour_score[2]")
			call("_read_sint16","com_start_score")
			call("_read_sint16","\tcom_neighbour_score[0]")
			call("_read_sint16","\tcom_neighbour_score[1]")
			call("_read_sint16","\tcom_neighbour_score[2]")
			call("_read_sint16","res_start_score")
			call("_read_sint16","\tres_neighbour_score[0]")
			call("_read_sint16","\tres_neighbour_score[1]")
			call("_read_sint16","\tres_neighbour_score[2]")

			filewrite browser "\n"
			call("_get_cityrules", "house_")
			filewrite browser "\n"
			call("_get_cityrules", "road_")
			filewrite browser "\n"

			if _version>102003
				call _get_speed_bonus
			endif
= end of online game
		endif
	endif

@@finish
	filewrite browser "\n"
	filewrite browser " finish","\n"
@@end
	fileclose editor
	fileclose browser
end

= *****************************************************************************
= local functions
= *****************************************************************************

local _read_bool
	var _t text _yesno char
	pop _t
	fileread editor _char

	filewrite browser _t," = ",_char,"\n"
	return
endlocal
local _read_uint8
	var _t text
	pop _t
	fileread editor _byte
	filewrite browser _t," = ",dec(_byte),"\n"
	return
endlocal
local _read_uint16
	var _t text
	pop _t
	fileread editor _word
	if _t == "<i>max_mountain_height</i>"
		filewrite browser "# ", _t," = ",dec(_word/51),"\n"
	endif
	filewrite browser _t," = ",dec(_word),"\n"
	return
endlocal
local _read_uint32
	var _t text
	pop _t
	fileread editor _longword
	filewrite browser _t," = ",dec(_longword),"\n"
	return
endlocal
local _read_sint16
	var _t text _sigword sigword
	pop _t
	fileread editor _sigword
	filewrite browser _t," = ",dec(_sigword),"\n"
	return
endlocal
local _read_sint32
	var _t text
	pop _t
	fileread editor _siglongword
	filewrite browser _t," = ",dec(_siglongword),"\n"
	return
endlocal
local _read_sint64
	var _t text
	pop _t
	fileread editor _sigqword
	filewrite browser _t," = ",dec(_sigqword),"\n"
	return
endlocal
local _read_double
	var _t text
	pop _t
	fileread editor _db
=	_db = double(_siglongword)
	filewrite browser _t," = ",_db,"\n"
	return
endlocal
local _read_text
	var _t text _w word
	var _key text
	pop _key
	fileread editor, _w
	fileread editor ,_t ,_w
	filewrite browser _key," = ",_t,"\n"


endlocal
local _get_player
	var _count byte _t text
	var _key text
	_count=0
	REPEAT
		filewrite browser "Player[",dec(_count-1),"]\n"
		_t ="\t<i>automaten</i>"
		call("_read_bool",_t)
		_t ="\t<i>spieler_type</i>"
		call("_read_uint8",_t)
=		fileseek editor,2,1
		if _version<=102002
			_key = "\tpassword="
			call("_read_text",_key)
		endif
	  _count=_count+1
	UNTIL _count==15

endlocal
local _get_player_color
	var _count byte _t text
	var _key text
	_count=0
	REPEAT
		filewrite browser "Player[",dec(_count),"]\n"
		_t ="\tcolor[0]"
		call("_read_uint8",_t)
		_t ="\tcolor[1]"
		call("_read_uint8",_t)
	  _count=_count+1
	UNTIL _count==16

endlocal
local _get_cityroad
	var _road_count word
	var _count word _t text
	_count=0
	fileread editor _road_count
	REPEAT
		filewrite browser "city_road[",dec(_count),"]\n"
		_t ="\ttype"
		call("_read_text",_t)
		call("_new_date",0)
		call("_new_date",1)
	  _count=_count+1
	UNTIL _count==_road_count

	_count=0
	fileread editor _road_count
	if _road_count>0
		REPEAT
			filewrite browser "intercity_road[",dec(_count),"]\n"
			_t ="\ttype"
			call("_read_text",_t)
			call("_new_date",0)
			call("_new_date",1)
		  _count=_count+1
		UNTIL _count==_road_count
	endif
endlocal
local _get_startingmoney
	var _count byte _t text
	var _key text
	_count=0

	REPEAT
		filewrite browser "startingmoney[",dec(_count),"]\n"
		_t ="\tyear"
		call("_read_sint16",_t)
		_t ="\tmoney"
		call("_read_sint64",_t)
		_t ="\tinterpol"
		call("_read_bool",_t)
	  _count=_count+1
	UNTIL _count==10
endlocal
local _get_localityfactor
	var _count byte _t text
	var _key text
	_count=0

	filewrite browser "# <b>localityfactor</b>\n"
	REPEAT
		filewrite browser "localityfactor[",dec(_count),"]\n"
		_t ="\tyear"
		call("_read_sint16",_t)
		_t ="\tfactor"
		call("_read_uint32",_t)
	  _count=_count+1
	UNTIL _count==10
endlocal
local _new_date
	var _c char _t text
	var _w word _year text _month text
	pop _c

	if (_c == 0)
	_t = "intro"
	else
	 _t = "retire"
	endif

	fileread editor _w
	filewrite browser "\t# ",_t," ",dec(_w)," year*12+(month-1)\n"
	_year = dec(_w / 12)
	_month = dec(_w mod 12 + 1)
	copytags _year _w
	copytags _month _w
	filewrite browser "\t", _t,"_year = ",_year,"\n\t",_t,"_month = ",_month,"\n"
	return
endlocal
local _get_speed_bonus
	var _t text

	filewrite browser "# speed bonus\n"

	_word = 1
	REPEAT
		_lcount = 0

		ifgoto _word, 1, sb1, 2, sb2, 3, sb3, 4, sb4, 5, sb5, 6, sb6, 7, sb7, 8, sb8

		@@sb1: _t = 'road': goto sb_out
		@@sb2: _t = 'track': goto sb_out
		@@sb3: _t = 'water': goto sb_out
		@@sb4: _t = 'air': goto sb_out
		@@sb5: _t = 'monorail': goto sb_out
		@@sb6: _t = 'maglev': goto sb_out
		@@sb7: _t = 'tram': goto sb_out
		@@sb8: _t = 'narrowgauge': goto sb_out

		@@sb_out

		fileread editor _dword
		filewrite browser "# ", _t, " ", dec(_dword),"\n"
		if _dword > 0
			REPEAT
				fileread editor _longword
				_longword2 = _longword / 12
				copytags _longword2, _longword
				filewrite browser "\tyear:",dec(_longword2)," "
				fileread editor _longword
				filewrite browser "\tspeed:",dec(_longword),"\n"
				inc _lcount
			UNTIL _lcount == _dword
		endif
		inc _word
	UNTIL _word == 9

	return
endlocal
local _get_cityrules
	var _item dword _c char _x byte _y byte _pos_x byte _pos_y byte  _i word _t text _type text

	fileread editor _dword
	pop _type
	filewrite browser "# ", _type ,"rules ", dec(_dword),"\n"

	_lcount=0
	REPEAT
		fileread editor _sigword
		filewrite browser _type ,dec(_lcount+1),".chance =",dec(_sigword),"\n"
		fileread editor _item
		filewrite browser _type ,dec(_lcount+1)," =\n"
		_i = 0
		_x = 0
		_y = 0
		REPEAT
			fileread editor _pos_x
			fileread editor _pos_y
			fileread editor _c

			if _pos_y != _y
				if _x != 0
					REPEAT
						if _y==3
							if _x==3
								filewrite browser "n"
							else
								filewrite browser "."
							endif
						else
							filewrite browser "."
						endif
						inc _x
					UNTIL _x == 7
					filewrite browser _t,"\n"
					_x = 0
					inc _y
				endif
				while _y != _pos_y
					if _y == 3
						filewrite browser _t,"...n...\n"
					else
						filewrite browser _t,".......\n"
					endif
					inc _y
				endwhile
			endif
			while _x < _pos_x
				if _x==3
					filewrite browser "n"
				else
					filewrite browser "."
				endif
				inc _x
			endwhile
			filewrite browser _c
			inc _x
			if _x == 7
				 _x=0
				 inc _y
				 filewrite browser "\n"
			endif
			inc _i
		UNTIL _item == _i

		if _x != 0
			REPEAT
				if _y==3
					if _x==3
						filewrite browser "n"
					else
						filewrite browser "."
					endif
				else
					filewrite browser "."
				endif
				inc _x
			UNTIL _x == 7
			filewrite browser _t,"\n"
			_x = 0
			inc _y
		endif
		while _y != 7
			if _y == 3
				filewrite browser _t,"...n...\n"
			else
				filewrite browser _t,".......\n"
			endif
			inc _y
		endwhile

		inc _lcount
	UNTIL _lcount == _dword
	return
endlocal
